/*
 * kernel/error.h
 * Copyright 1996, Onno Hovers, All rights reserved  
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; see the file COPYING.LIB. If
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave,
 * Cambridge, MA 02139, USA.  
 */
 
#ifndef __KERNEL_ERROR_H
#define __KERNEL_ERROR_H

#include<stdlib.h>
#include<errno.h>
#include<win32/defines.h>
#include<win32/error.h>
#include<win32/kernel.h>
#include"exe.h"
#include"peload.h"
#include"run.h"

#ifdef __cplusplus
extern "C" {
#endif

DWORD LastError;

void _exp_unknown(ULONG stuff, LPSTR fname );
void _exp_unimp(ULONG stuff, LPSTR name1, LPSTR name2);

VOID   SetLastError(DWORD err);
DWORD  GetLastError(VOID);

HANDLE __ErrorReturnInvalid(DWORD err);
BOOL   __ErrorReturnFalse(DWORD err);
PVOID  __ErrorReturnNull(DWORD err);
DWORD  __ErrorFromErrno(int err);

#ifdef __cplusplus
}
#endif

#endif