/*
 *  kernel/fs.h
 *  Copyright (C) 1996, Onno Hovers, All rights reserved
 *
 *  filesystem functions
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; see the file COPYING.LIB. If
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave,
 * Cambridge, MA 02139, USA.  
 */

#ifndef __KERNEL_FS_H
#define __KERNEL_FS_H

#ifdef __cplusplus
extern "C" {
#endif

/* unix includes */
#include<unistd.h>
#include<dirent.h>
#include<string.h>
#include<sys/stat.h>
#include<sys/fcntl.h>

/* Win32 includes */
#include<win32/defines.h>
#include<win32/error.h>
#include<win32/kernel.h>

BOOL __FsInit(VOID);
int __FsAccessFlags(DWORD faccess);
int __FsCreationFlags(DWORD fcreate);
DWORD __FsModeToAttrib(int mode);
int __FsAttribToMode(DWORD attrib);
BOOL __FsUTCToFileTime( ULONG utc, PFILETIME pfiletime );
DWORD __FsFileTimeToUTC( CONST FILETIME *pfiletime);
DWORD __FsFindNameFlags( DWORD fcreate );

#define FINDNAME_DIR        1
#define FINDNAME_FILE       2
#define FINDNAME_EXIST      4
#define FINDNAME_NEW        8 

VOID __FsChangeSeparator(LPSTR pathname, CHAR sep);
BOOL __FsFindNameA(LPSTR fullname, LPSTR unixname, 
                 LPSTR pcertain, INT count, INT flags);
BOOL __FsGetNameA(LPCSTR shortname, LPSTR fullname, LPSTR unixname, 
                LPSTR *ppcertain, INT count);
BOOL __FsGetFullPathNameA(LPCSTR pathname, LPSTR fullname, INT buflen);

#ifdef __cplusplus
}
#endif

#endif