/* 
 * kernel/handle.h
 * Copyright (C) 1996, Onno Hovers, All rights reserved
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; see the file COPYING.LIB. If
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave,
 * Cambridge, MA 02139, USA.  
 */
 
#ifndef __HANDLE_H
#define __HANDLE_H

#include <stddef.h>
#include <win32/defines.h>
#include <win32/error.h>
#include <win32/kernel.h>
#include <win32/security.h>
#include "object.h"
#include "wfc.h"

#ifdef __cplusplus
extern "C" {
#endif

/*
 * general kernel object definitions
 */

struct __KERNEL_OBJECT;

 
typedef struct __HANDLE_DATA
{
   struct __KERNEL_OBJECT  *Object;
   DWORD                    Access;
} HANDLE_DATA;

typedef struct __HANDLE_DATA *PHANDLE_DATA;

HANDLE_DATA ***__HandleArray;

#define HANDLE_START 0xC0000000
#define HANDLE_END   0xC0007FFF

BOOL __HandleInit(VOID);
HANDLE __HandleAlloc(struct __KERNEL_OBJECT *object, DWORD access);
BOOL __HandleFree(HANDLE handle);
BOOL __HandleCheckAccess(HANDLE handle, DWORD required);

PHANDLE_DATA __HandleGet(HANDLE handle);
struct __KERNEL_OBJECT *__HandleGetIndirect(PHANDLE_DATA phdata, DWORD required,
                                       DWORD typeid);
struct __KERNEL_OBJECT *__HandleGetObject(HANDLE handle, DWORD required,
                                     DWORD typeid);BOOL __HandleExit(VOID);
                                     
#ifdef __cplusplus
}
#endif

#endif