/*
 * kernel/heap.h
 *
 */

/* alloc. size	admin size:	size of subblock (+hdr)  allocations */
 * 16		32		1K			 31             
 * 32		48		1K			  
 * 48           64 		1K
 * 64	        80		  
 * 128		144  
 * 256		272		16 
 */

#define HEAP_16_BIT_ALIGN

typedef struct __HEAP_BLOCK
{
  WORD				Magic;
  WORD 				MoreMagic;
  DWORD				Size;
  struct __HEAP_BLOCK		*Prev;
  struct __HEAP_BLOCK		*Next;
  BYTE                          Memory[ANYSIZE_ARRAY];
} HEAP_BLOCK;

typedef struct __HEAP_SUBBLOCK
{
  WORD				Magic;
  BYTE				Bitmap;  
  BYTE 				Size		/* total size in K */
  struct __HEAP_SUBBLOCK	*NextSub; 
  struct __HEAP_BLOCK		*Prev;
  struct __HEAP_BLOCK		*Next;
  BYTE				Memory[ANYSIZE_ARRAY];
} HEAP_SUBBLOCK;

typedef struct __HEAP_SUBALLOC
{
   DWORD Magic;
   DWORD Size;
#ifdef HEAP_16_BYTE_ALIGN   
   DWORD reserved1;
   DWORD reserved2;  
#endif
   BYTE  Memory[ANYSIZE_ARRAY];   
}