/*
 * i386/stdcall.h
 * Copyright 1996, Onno Hovers, All rights reserved
 */
 
#ifndef __I386_STDCALL_H
#define __I386_STDCALL_H


#if defined(__GNUC__) && defined(i386)

ULONG static inline __stdcall1 (PVOID proc, ULONG arg1)
{								  
   register int ret;
   
   __asm__("\tpushl %2\n\tcall %1\n"
           :"=a" (ret)
           :"p"  (proc), "r" (arg1) 
           :"memory");
   return  ret;
} 

ULONG static inline __stdcall2 (PVOID proc, ULONG arg1, ULONG arg2)
{								  
   register int ret;
   
   __asm__("\tpushl %3\n\tpushl %2\n\tcall %1\n"
           :"=a" (ret)
           :"p" (proc), "r" (arg1), "r" (arg2)
           :"memory");
   return  ret;
} 

ULONG static inline __stdcall3 (PVOID proc, ULONG arg1, ULONG arg2,
                                    ULONG arg3)                       
{								  
   register int ret;
   
   __asm__("\tpushl %4\n\tpushl %3\n\tpushl %2\n\tcall %1\n"
           :"=a" (ret)
           :"p" (proc), "r" (arg1), "r" (arg2), "r" (arg3)
           :"memory");
   return  ret;
} 

ULONG static inline __stdcall4 (PVOID proc, ULONG arg1, ULONG arg2,
                                    ULONG arg3, ULONG arg4, ULONG arg5)		
{								  
   register int ret;
   
   __asm__("\tpushl %5\n\tpushl %4\n"
           "\tpushl %3\n\tpushl %2\n\tcall %1\n"
           :"=a" (ret)
           :"p" (proc), "r" (arg1), "r" (arg2),
            "r" (arg3), "r" (arg4) 
           :"memory");
   return  ret;
} 

ULONG static inline __stdcall5 (PVOID proc, ULONG arg1, ULONG arg2,
                                    ULONG arg3, ULONG arg4, ULONG arg5)		
{								  
   register int ret;
   
   __asm__("\tpushl %6\n\tpushl %5\n\tpushl %4\n"
           "\tpushl %3\n\tpushl %2\n\tcall %1\n"
           :"=a" (ret)
           :"p" (proc), "r" (arg1), "r" (arg2),
            "r" (arg3), "r" (arg4), "r" (arg5)
           :"memory");
   return  ret;
} 

#endif

#endif  __I386_STDCALL_H