/*
 * kernel/ipc.h 
 * Copyright (C) 1996, Onno Hovers, All rights reserved
 *
 * inter process/thread communication support functions
 *  
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; see the file COPYING.LIB. If
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave,
 * Cambridge, MA 02139, USA.  
 *
 * we enter a global kind of critical section for
 * synchronization, if the system supports kernel threads
 */

#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <linux/unistd.h>

#ifdef NOTYET
/*
 * this exists in shared address space 
 * it's used for a mutex, semaphore or event.  
 */
typedef struct __PERIPC
{  
   int                   Semaphore;	/* semaphore id */
   ULONG		 RefCount;      /* number of handles */
   ULONG		 SemCount;	/* semaphore count */
   ULONG		 Recurse;       /* recurse count */  	 
   struct __WAITER	*Waiter;	/* waiting threads */
   PPERTHREAD		*Owner;     	/* owning thread */
} PERIPC, *PPERIPC;

#endif