/* 
 * kernel/itime.c
 * Copyright (C) 1996, Onno Hovers, All rights reserved
 *
 * time functions
 * 
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; see the file COPYING.LIB. If
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave,
 * Cambridge, MA 02139, USA.  
 */

#ifndef __KERNEL_ITIME_H
#define __KERNEL_ITIME_H

#include<time.h>
#include<sys/time.h>
#include<win32/defines.h>
#include<win32/kernel.h>

#ifdef __cplusplus
extern "C" {
#endif

/* these definitions are from cyg-win32's winsup/times.cc */
#define FACTOR		(0x19DB1DED53EA710LL)
#define NSPERSEC	10000000LL
#define NSPERMSEC	10000LL
#define NSPERUSEC	10LL

typedef struct __DOSTIME
{
   WORD	Second:5; 
   WORD	Minute:6;
   WORD Hour:5;
} DOSTIME, *PDOSTIME;

typedef struct __DOSDATE
{
   WORD	Day:5; 
   WORD	Month:4;
   WORD Year:5;
} DOSDATE, *PDOSDATE;


time_t __TimeFileToUnix (FILETIME ftime);
FILETIME  __TimeUnixToFile (time_t utime);

#ifdef __cplusplus
}
#endif
#endif 