/*
 * kernel/process.h
 * Copyright (C) 1996,  Onno Hovers, All rights reserved
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; see the file COPYING.LIB. If
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave,
 * Cambridge, MA 02139, USA.  
 */
  
#ifndef __KERNEL_PROCESS_H
#define __KERNEL_PROCESS_H

#include <sys/types.h>
#include <win32/defines.h>
#include <win32/kernel.h>
#include <win32/error.h>
#include "wfc.h"

#ifdef __cplusplus
extern "C" {
#endif

#define PROC_HSELF ((HANDLE) 0x80000000)

#ifdef NOTYET
typedef struct __PERPROCESS
{
  pid_t			pid;
  ULONG			Count;
  struct __PERTHREAD	FirstThread;
  UINT			ExitCode;	
} PERPROCESS, *PPERPROCESS;
#endif

VOID  NORETURN  __ProcessExit(INT exitcode);
VOID  NORETURN  __ProcessStart(VOID);
VOID   ExitProcess(UINT exitcode);
HANDLE GetCurrentProcess(VOID);
DWORD  GetCurrentProcessId(VOID);

#ifdef __cplusplus
}
#endif

#endif
