/*
 * teb.h
 * Copyright (C) 1996, Onno Hovers, All rights reserved
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; see the file COPYING.LIB. If
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave,
 * Cambridge, MA 02139, USA.  
 */
 
 
#ifndef __TEB_H
#define __TEB_H

#include <win32/defines.h>
#include "lctable.h"

/* 
 * documented by Matt Pietrek in an article in MSJ
 * thread local variables must be declared here! 
 *
 */
typedef struct __TEB
{
   LPVOID Except;
   LPVOID StackHigh;
   LPVOID StackLow;    
   LPVOID SubSystem;
   ULONG  Version;
   ULONG  User;
   LPVOID Self;
   ULONG  reserved1;
   ULONG  reserved2;
   ULONG  reserved3;
   ULONG  reserved4;
   LPVOID TlsArray;
   /* and now our stuff */
   PLOCALE  Locale;	/* at offset 0xC4 in WinNT is the LCID */
   ULONG  LastError;	/* at offset 0x34 in WinNT, 0x70 in Win95 */
   ULONG  ThreadId;   
} TEB;

typedef struct __TEB *PTEB;

#ifdef __i386__
extern TEB Teb __asm__("%%fs:0");

extern LPVOID	__TebExcept    __asm__("%fs:(0)");
extern LPVOID	__TebStackLow  __asm__("%fs:(4)");
extern LPVOID	__TebStackHigh __asm__("%fs:(8)");
extern LPVOID   __TebTlsArray  __asm__("%fs:(0x2C)");
extern PLOCALE	__TebLocale    __asm__("%fs:(0x30)");
extern ULONG	__TebLastError __asm__("%fs:(0x34)");
#endif

#endif /* __TEB_H */