/*
 * include/wfc.h
 * Copyright 1996, Onno Hovers, All rights reserved  
 * 
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; see the file COPYING.LIB. If
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave,
 * Cambridge, MA 02139, USA.  
 */
  
#ifndef __WFC_WFC_H
#define __WFC_WFC_H

#include<stdio.h>
#include<win32/defines.h>
#include<win32/kernel.h>
#include"config.h"
#include"imalloc.h"

#ifdef __cplusplus
extern "C" {
#endif

/* user serviceable parts */
#define DEBUG		/* enable debugging output */
#undef  __WindowsEmulate /* we want to be able to emulate more things */

/* no user serviceable parts beyond this */

/* general definitions */
#ifdef __GNUC__
#define NORETURN __attribute__ ((noreturn))
#else
#define NORETURN
#endif


VOID dprintf(const char *fmt, ...);  /* debugging   */

#ifndef DEBUG
#define dprintf      while(0) dprintf
#endif
#define aprintf	     dprintf

/* I guest microsoft will never use this platform id */ 
#define VER_PLATFORM_WIN32_FREE	('F'+('r'<<8)+('e'<<16)+('e'<<24))

#define NATIVE		(__WindowsEmulate==VER_PLATFORM_WIN32_FREE)
#define WIN32S_ISMS	(__WindowsEmulate==VER_PLATFORM_WIN32s)	
#define WIN95_ISMS	(__WindowsEmulate==VER_PLATFORM_WIN32_WINDOWS )
#define NT_ISMS		(__WindowsEmulate==VER_PLATFORM_WIN32_NT )

/* global variables */
#ifndef __WindowsEmulate
extern ULONG 		__WindowsEmulate;
#endif
extern ULONG 		__WindowsVersion;
extern ULONG		__WindowsBuild;
extern STARTUPINFOA	__StartupInfoA;
extern LPSTR		__CommandLineA;
extern LPSTR		__EnvironmentA;
extern CHAR		__UnixCurrentDirectory[MAX_PATH]; /* unix cwd */
extern CHAR 		__CurrentDirectoryA[MAX_PATH];	/* current directory */
extern ULONG		__EnvironmentSize;	/* size of the environment block */
extern ULONG		__EnvironmentAlloc;	/* allocated for environment block */
extern HANDLE		__HStdIn;
extern HANDLE		__HStdOut;
extern HANDLE		__HStdErr;
extern HANDLE		__Heap;			/* process heap */

/* debugging and spying */
extern BOOL		__DbgLog;
extern FILE *		__DbgOut;
extern BOOL		__ApiLog;
extern FILE *		__ApiOut;

#ifdef __cplusplus
}
#endif

#endif