/*
 * win32/context.h
 * (c) 1996, Onno Hovers, All rights reserved
 */

#ifndef __WIN32_CONTEXT_H
#define __WIN32_CONTEXT_H

#include <win32/types.h>

#if defined(_X86_)

#define CONTEXT_i386                   0x00010000                 
#define CONTEXT_CONTROL                0x00010001
#define CONTEXT_INTEGER                0x00010002
#define CONTEXT_SEGMENTS               0x00010004
#define CONTEXT_FLOATING_POINT         0x00010008
#define CONTEXT_DEBUG_REGISTERS        0x00010010
#define CONTEXT_FULL                   0x00010007

/*
 * The i386 context used by Win32 for almost everything. 
 */
  
#define SIZE_OF_80387_REGISTERS      80

typedef struct _FLOATING_SAVE_AREA
{
    DWORD   ControlWord;
    DWORD   StatusWord;
    DWORD   TagWord;    
    DWORD   ErrorOffset;
    DWORD   ErrorSelector;
    DWORD   DataOffset;
    DWORD   DataSelector;    
    BYTE    RegisterArea[SIZE_OF_80387_REGISTERS];
    DWORD   Cr0NpxState;
} FLOATING_SAVE_AREA;

typedef struct __CONTEXT
{
    DWORD   ContextFlags;
    DWORD   Dr0;
    DWORD   Dr1;    
    DWORD   Dr2;    
    DWORD   Dr3;
    DWORD   Dr6;
    DWORD   Dr7;    
    FLOATING_SAVE_AREA FloatSave;
    DWORD   SegGs;
    DWORD   SegFs;
    DWORD   SegEs;
    DWORD   SegDs;    
    DWORD   Edi;
    DWORD   Esi;
    DWORD   Ebx;
    DWORD   Edx;    
    DWORD   Ecx;
    DWORD   Eax;
    DWORD   Ebp;    
    DWORD   Eip;
    DWORD   SegCs;
    DWORD   EFlags;
    DWORD   Esp;
    DWORD   SegSs;
} CONTEXT;

#endif 

typedef struct __CONTEXT *PCONTEXT;

#endif /* __WINE_CONTEXT_H */