/* 
 * win32/nls.h
 *
 * National Language Support definitions
 *
 * Copyright (C) 1996 Free Software Foundation, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *   
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */ 

#ifndef __WIN32_NLS_H
#define __WIN32_NLS_H

#include<win32/defines.h>
#include<win32/kernel.h>

#ifdef __cplusplus
extern "C" {
#endif 

#define CAL_GREGORIAN			1
#define CAL_GREGORIAN_US		2
#define CAL_JAPAN 			3
#define CAL_TAIWAN			4
#define CAL_KOREA      			5 

#define CAL_ICALINTVALUE		1
#define CAL_SCALNAME			2
#define CAL_IYEAROFFSETRANGE		3
#define CAL_SERASTRING			4
#define CAL_SSHORTDATE			5
#define CAL_SLONGDATE			6
#define CAL_SDAYNAME1			7
#define CAL_SDAYNAME2			8
#define CAL_SDAYNAME3			9
#define CAL_SDAYNAME4			10
#define CAL_SDAYNAME5			11
#define CAL_SDAYNAME6			12
#define CAL_SDAYNAME7			13
#define CAL_SABBREVDAYNAME1		14
#define CAL_SABBREVDAYNAME2		15
#define CAL_SABBREVDAYNAME3		16
#define CAL_SABBREVDAYNAME4		17
#define CAL_SABBREVDAYNAME5		18
#define CAL_SABBREVDAYNAME6		19
#define CAL_SABBREVDAYNAME7		20
#define CAL_SMONTHNAME1			21
#define CAL_SMONTHNAME2			22
#define CAL_SMONTHNAME3			23
#define CAL_SMONTHNAME4			24
#define CAL_SMONTHNAME5			25
#define CAL_SMONTHNAME6			26
#define CAL_SMONTHNAME7			27
#define CAL_SMONTHNAME8			28
#define CAL_SMONTHNAME9			29
#define CAL_SMONTHNAME10		30
#define CAL_SMONTHNAME11		31
#define CAL_SMONTHNAME12		32
#define CAL_SMONTHNAME13		33
#define CAL_SABBREVMONTHNAME1		34
#define CAL_SABBREVMONTHNAME2		35
#define CAL_SABBREVMONTHNAME3		36
#define CAL_SABBREVMONTHNAME4		37
#define CAL_SABBREVMONTHNAME5		38
#define CAL_SABBREVMONTHNAME6		39
#define CAL_SABBREVMONTHNAME7		40
#define CAL_SABBREVMONTHNAME8		41
#define CAL_SABBREVMONTHNAME9		42
#define CAL_SABBREVMONTHNAME10		43
#define CAL_SABBREVMONTHNAME11		44
#define CAL_SABBREVMONTHNAME12		45
#define CAL_SABBREVMONTHNAME13		46

#define CP_INSTALLED			1
#define CP_SUPPORTED			2

#define CP_ACP				0
#define CP_OEMCP			1
#define CP_MACCP			2

#define CT_CTYPE1			0x1
#define CT_CTYPE2			0x2
#define CT_CTYPE3			0x4

/*
 * country code based on telephone country code, except for Canada, 
 * which uses 2 instead of 1 (1 is also used by the U.S.A )
 */
#define CTRY_DEFAULT			0
#define CTRY_AUSTRALIA			61
#define CTRY_AUSTRIA			43
#define CTRY_BELGIUM			32
#define CTRY_BRAZIL			55
#define CTRY_BULGARIA			359
#define CTRY_CANADA			2
#define CTRY_CROATIA			385
#define CTRY_CZECH			42
#define CTRY_DENMARK			45
#define CTRY_FINLAND			358
#define CTRY_FRANCE			33
#define CTRY_GERMANY			49
#define CTRY_GREECE			30
#define CTRY_HONG_KONG			852
#define CTRY_HUNGARY			36
#define CTRY_ICELAND			354
#define CTRY_IRELAND			353
#define CTRY_ITALY			39
#define CTRY_JAPAN			81
#define CTRY_MEXICO			52
#define CTRY_NETHERLANDS		31
#define CTRY_NEW_ZEALAND		64
#define CTRY_NORWAY			47
#define CTRY_POLAND			48
#define CTRY_PORTUGAL			351
#define CTRY_PRCHINA			86
#define CTRY_ROMANIA			40
#define CTRY_RUSSIA			7
#define CTRY_SINGAPORE			65
#define CTRY_SLOVAK			42
#define CTRY_SLOVENIA			386
#define CTRY_SOUTH_KOREA		82
#define CTRY_SPAIN			34
#define CTRY_SWEDEN			46
#define CTRY_SWITZERLAND		41
#define CTRY_TAIWAN			886
#define CTRY_TURKEY			90
#define CTRY_UNITED_KINGDOM		44
#define CTRY_UNITED_STATES		1

#define C1_UPPER			0x0001
#define C1_LOWER			0x0002
#define C1_DIGIT			0x0004
#define C1_SPACE			0x0008
#define C1_PUNCT			0x0010
#define C1_CNTRL			0x0020
#define C1_BLANK			0x0040
#define C1_XDIGIT			0x0080
#define C1_ALPHA			0x0100

#define C2_NOTAPPLICABLE		0
#define C2_LEFTTORIGHT			1
#define C2_RIGHTTOLEFT			2
#define C2_EUROPENUMBER			3
#define C2_EUROPESEPARATOR		4
#define C2_EUROPETERMINATOR		5
#define C2_ARABICNUMBER			6
#define C2_COMMONSEPARATOR		7
#define C2_BLOCKSEPARATOR		8
#define C2_SEGMENTSEPARATOR		9
#define C2_WHITESPACE			10
#define C2_OTHERNEUTRAL			11

#define C3_NOTAPPLICABLE		0x0000
#define C3_NONSPACING			0x0001
#define C3_DIACRITIC			0x0002
#define C3_VOWELMARK			0x0004
#define C3_SYMBOL			0x0008
#define C3_KATAKANA			0x0010
#define C3_HIRAGANA			0x0020
#define C3_HALFWIDTH			0x0040
#define C3_FULLWIDTH			0x0080
#define C3_IDEOGRAPH			0x0100
#define C3_KASHIDA			0x0200
#define C3_LEXICAL			0x0400
#define C3_ALPHA			0x8000

#define DATE_SHORTDATE			0x01
#define DATE_LONGDATE			0x02
#define DATE_USE_ALT_CALENDAR		0x04

#define ENUM_ALL_CALENDARS		0xFFFFFFFF

/*
 * Primary language ids: some more obscure ids are from 
 * "Developing International Software" by Nadine Kano
 */
  
#define LANG_NEUTRAL			0x00
#define LANG_ARABIC			0x01
#define LANG_BULGARIAN			0x02
#define LANG_CATALAN			0x03
#define LANG_CHINESE			0x04
#define LANG_CZECH			0x05
#define LANG_DANISH			0x06
#define LANG_GERMAN			0x07
#define LANG_GREEK			0x08
#define LANG_ENGLISH			0x09
#define LANG_SPANISH			0x0A
#define LANG_FINNISH			0x0B
#define LANG_FRENCH			0x0C
#define LANG_HEBREW			0x0D
#define LANG_HUNGARIAN			0x0E
#define LANG_ICELANDIC			0x0F
#define LANG_ITALIAN			0x10
#define LANG_JAPANESE			0x11
#define LANG_KOREAN			0x12
#define LANG_DUTCH			0x13
#define LANG_NORWEGIAN			0x14
#define LANG_POLISH			0x15
#define LANG_PORTUGUESE			0x16
#define LANG_RHAETOROMANIC		0x17
#define LANG_ROMANIAN			0x18
#define LANG_RUSSIAN			0x19
#define LANG_CROATIAN			0x1A
#define LANG_SLOVAK			0x1B
#define LANG_ALBANIAN			0x1C
#define LANG_SWEDISH			0x1D
#define LANG_THAI			0x1E
#define LANG_TURKISH			0x1F
#define LANG_URDU			0x20
#define LANG_INDONESIAN			0x21
#define LANG_UKRAINIAN			0x22
#define LANG_BYELORUSSIAN		0x23
#define LANG_SLOVENIAN			0x24
#define LANG_ESTONIAN			0x25
#define LANG_LATVIAN			0x26
#define LANG_LITHUANIAN			0x27
#define LANG_MAORI			0x28
#define LANG_FARSI			0x29
#define LANG_VIETNAMESE			0x2A
#define LANG_LAOTIAN			0x2B
#define LANG_KAMPUCHEAN			0x2C
#define LANG_BASQUE			0x2D
#define LANG_SORBIAN			0x2E
#define LANG_MACEDONIAN			0x2F
#define LANG_SUTU			0x30
#define LANG_TSONGA			0x31
#define LANG_TSWANA			0x32
#define LANG_VENDA			0x33
#define LANG_XHOSA			0x34
#define LANG_ZULU			0x35
#define LANG_AFRIKAANS			0x36
#define LANG_FAEROESE			0x38
#define LANG_HINDI			0x39
#define LANG_MALTESE			0x3A
#define LANG_SAMI			0x3B
#define LANG_SCOTSGAELIC		0x3C

#define LCID_INSTALLED			1
#define LCID_SUPPORTED			2

#define LCMAP_LOWERCASE			0x00000100
#define LCMAP_UPPERCASE			0x00000200
#define LCMAP_SORTKEY			0x00000400
#define LCMAP_BYTEREV			0x00000800

#define LCMAP_HIRAGANA			0x00100000
#define LCMAP_KATAKANA			0x00200000
#define LCMAP_HALFWIDTH			0x00400000
#define LCMAP_FULLWIDTH			0x00800000

#define LOCALE_USER_DEFAULT		0x400
#define LOCALE_SYSTEM_DEFAULT		0x800

#define LOCALE_ILANGUAGE		1
#define LOCALE_SLANGUAGE		2
#define LOCALE_SABBREVLANGNAME		3
#define LOCALE_SNATIVELANGNAME		4
#define LOCALE_ICOUNTRY			5
#define LOCALE_SCOUNTRY			6
#define LOCALE_SABBREVCTRYNAME		7
#define LOCALE_SNATIVECTRYNAME		8
#define LOCALE_IDEFAULTLANGUAGE		9
#define LOCALE_IDEFAULTCOUNTRY		10
#define LOCALE_IDEFAULTCODEPAGE		11
#define LOCALE_SLIST			12
#define LOCALE_IMEASURE			13
#define LOCALE_SDECIMAL			14
#define LOCALE_STHOUSAND		15
#define LOCALE_SGROUPING		16
#define LOCALE_IDIGITS			17
#define LOCALE_ILZERO			18
#define LOCALE_SNATIVEDIGITS		19
#define LOCALE_SCURRENCY		20
#define LOCALE_SINTLSYMBOL		21
#define LOCALE_SMONDECIMALSEP		22
#define LOCALE_SMONTHOUSANDSEP		23
#define LOCALE_SMONGROUPING		24
#define LOCALE_ICURRDIGITS		25
#define LOCALE_IINTLCURRDIGITS		26
#define LOCALE_ICURRENCY		27
#define LOCALE_INEGCURR			28
#define LOCALE_SDATE			29
#define LOCALE_STIME			30
#define LOCALE_SSHORTDATE		31
#define LOCALE_SLONGDATE		32
#define LOCALE_IDATE			33
#define LOCALE_ILDATE			34
#define LOCALE_ITIME			35
#define	LOCALE_ICENTURY			36
#define LOCALE_ITLZERO			37
#define LOCALE_IDAYLZERO		38
#define LOCALE_IMONLZERO		39
#define LOCALE_S1159			40
#define LOCALE_S2359			41
#define LOCALE_SDAYNAME1		42
#define LOCALE_SDAYNAME2		43
#define LOCALE_SDAYNAME3		44
#define LOCALE_SDAYNAME4		45
#define LOCALE_SDAYNAME5		46
#define LOCALE_SDAYNAME6		47
#define LOCALE_SDAYNAME7		48
#define LOCALE_SABBREVDAYNAME1		49
#define LOCALE_SABBREVDAYNAME2		50
#define LOCALE_SABBREVDAYNAME3		51
#define LOCALE_SABBREVDAYNAME4		52
#define LOCALE_SABBREVDAYNAME5		53
#define LOCALE_SABBREVDAYNAME6		54
#define LOCALE_SABBREVDAYNAME7		55
#define LOCALE_SMONTHNAME1		56
#define LOCALE_SMONTHNAME2		57
#define LOCALE_SMONTHNAME3		58
#define LOCALE_SMONTHNAME4		59
#define LOCALE_SMONTHNAME5		60
#define LOCALE_SMONTHNAME6		61
#define LOCALE_SMONTHNAME7		62
#define LOCALE_SMONTHNAME8		63
#define LOCALE_SMONTHNAME9		64
#define LOCALE_SMONTHNAME10		65
#define LOCALE_SMONTHNAME11		66
#define LOCALE_SMONTHNAME12		67
#define LOCALE_SABBREVMONTHNAME1	68
#define LOCALE_SABBREVMONTHNAME2	69
#define LOCALE_SABBREVMONTHNAME3	70
#define LOCALE_SABBREVMONTHNAME4	71
#define LOCALE_SABBREVMONTHNAME5	72
#define LOCALE_SABBREVMONTHNAME6	73
#define LOCALE_SABBREVMONTHNAME7	74
#define LOCALE_SABBREVMONTHNAME8	75
#define LOCALE_SABBREVMONTHNAME9	76
#define LOCALE_SABBREVMONTHNAME10	77
#define LOCALE_SABBREVMONTHNAME11	78
#define LOCALE_SABBREVMONTHNAME12	79
#define LOCALE_SPOSITIVESIGN		80
#define LOCALE_SNEGATIVESIGN		81
#define LOCALE_IPOSSIGNPOSN		82
#define LOCALE_INEGSIGNPOSN		83
#define LOCALE_IPOSSYMPRECEDES		84
#define LOCALE_IPOSSEPBYSPACE		85
#define LOCALE_INEGSYMPRECEDES		86
#define LOCALE_INEGSEPBYSPACE		87
#define LOCALE_FONTSIGNATURE		88
#define LOCALE_SENGLANGUAGE		0x1001
#define LOCALE_SENGCOUNTRY		0x1002
#define LOCALE_STIMEFORMAT		0x1003
#define LOCALE_IDEFAULTANSICODEPAGE	0x1004
#define LOCALE_ITIMEMARKPOSN		0x1005
#define LOCALE_ICALENDARTYPE		0x1009
#define LOCALE_IOPTIONALCALENDAR	0x100B
#define LOCALE_IFIRSTDAYOFWEEK		0x100C
#define LOCALE_IFIRSTWEEKOFYEAR		0x100D
#define LOCALE_SMONTHNAME13		0x100E
#define LOCALE_SABBREVMONTHNAME13	0x100F
#define LOCALE_INEGNUMBER		0x1010
#define LOCALE_USE_CP_ACP		0x40000000
#define LOCALE_NOUSEROVERRIDE		0x80000000

#define MAP_FOLDCZONE			0x00000010
#define MAP_PRECOMPOSED			0x00000020
#define MAP_COMPOSITE			0x00000040
#define MAP_FOLDDIGITS			0x00000080

#define MAX_DEFAULTCHAR			2
#define MAX_LEADBYTES			12

#define MB_PRECOMPOSED			0x01
#define MB_COMPOSITE			0x02
#define MB_USEGLYPHCHARS		0x04
#define MB_ERR_INVALID_CHARS		0x08

#define NLS_VALID_LOCALE_MASK		0x000FFFFF

#define NORM_IGNORECASE			0x00000001
#define NORM_IGNORENONSPACE		0x00000002
#define NORM_IGNORESYMBOLS		0x00000004

#define NORM_IGNOREKANATYPE		0x00010000
#define NORM_IGNOREWIDTH		0x00020000

#define SORT_STRINGSORT			0x1000

#define SORT_DEFAULT			0
#define SORT_JAPANESE_XJIS		0
#define SORT_JAPANESE_UNICODE		1
#define SORT_CHINESE_BIG5		0
#define SORT_CHINESE_UNICODE		1
#define SORT_KOREAN_KSC			0
#define SORT_KOREAN_UNICODE		1

#define SUBLANG_NEUTRAL			0
#define SUBLANG_DEFAULT			1
#define SUBLANG_SYS_DEFAULT		2
#define SUBLANG_ARABIC			1
#define SUBLANG_ARABIC_IRAQ		2	
#define SUBLANG_ARABIC_EGYPT		3
#define SUBLANG_ARABIC_LIBYA		4
#define SUBLANG_ARABIC_ALGERIA		5
#define SUBLANG_ARABIC_MOROCCO		6
#define SUBLANG_ARABIC_TUNISIA		7
#define SUBLANG_ARABIC_OMAN		8
#define SUBLANG_ARABIC_YEMEN		9
#define SUBLANG_ARABIC_SYRIA		0x10
#define SUBLANG_ARABIC_JORDAN		0x11
#define SUBLANG_ARABIC_LEBANON		0x12
#define SUBLANG_ARABIC_KUWAIT		0x13
#define SUBLANG_ARABIC_UAE		0x14
#define SUBLANG_ARABIC_BAHRAIN		0x15
#define SUBLANG_ARABIC_QATAR		0x16
#define SUBLANG_CHINESE_TRADITIONAL	1
#define SUBLANG_CHINESE_SIMPLIFIED	2
#define SUBLANG_CHINESE_HONGKONG	3
#define SUBLANG_CHINESE_SINGAPORE	4
#define SUBLANG_DUTCH			1
#define SUBLANG_DUTCH_BELGIAN		2
#define SUBLANG_ENGLISH_US		1
#define SUBLANG_ENGLISH_UK		2
#define SUBLANG_ENGLISH_AUS		3
#define SUBLANG_ENGLISH_CAN		4
#define SUBLANG_ENGLISH_NZ		5
#define SUBLANG_ENGLISH_EIRE		6
#define SUBLANG_ENGLISH_SAFRICA		7
#define SUBLANG_ENGLISH_JAMAICA		8
#define SUBLANG_ENGLISH_CARRIBEAN	9
#define SUBLANG_FRENCH			1
#define SUBLANG_FRENCH_BELGIAN		2
#define SUBLANG_FRENCH_CANADIAN		3
#define SUBLANG_FRENCH_SWISS		4
#define SUBLANG_FRENCH_LUXEMBOURG	5
#define SUBLANG_GERMAN			1
#define SUBLANG_GERMAN_SWISS		2
#define SUBLANG_GERMAN_AUSTRIAN		3
#define SUBLANG_GERMAN_LIECHTENSTEIN	5
#define SUBLANG_ITALIAN			1
#define SUBLANG_ITALIAN_SWISS		2
#define SUBLANG_KOREAN			1
#define SUBLANG_KOREAN_JOHAB		2
#define SUBLANG_NORWEGIAN_BOKMAL	1
#define SUBLANG_NORWEGIAN_NYNORSK	2
#define SUBLANG_PORTUGUESE_BRAZILIAN	1
#define SUBLANG_PORTUGUESE		2
#define SUBLANG_SPANISH			1
#define SUBLANG_SPANISH_MEXICAN		2
#define SUBLANG_SPANISH_MODERN		3
#define SUBLANG_SPANISH_GUATEMALA	4
#define SUBLANG_SPANISH_COSTARICA	5	
#define SUBLANG_SPANISH_PANAMA		6
#define SUBLANG_SPANISH_DOMINICAN	7	
#define SUBLANG_SPANISH_VENEZUELA	8	
#define SUBLANG_SPANISH_COLOMBIA	9	
#define SUBLANG_SPANISH_PERU		0x10
#define SUBLANG_SPANISH_ARGENTINA	0x11	
#define SUBLANG_SPANISH_ECUADOR		0x12
#define SUBLANG_SPANISH_CHILE		0x13
#define SUBLANG_SPANISH_URUGUAY		0x14
#define SUBLANG_SPANISH_PARAGUAY	0x15	
#define SUBLANG_SPANISH_BOLIVIA		0x16

#define TIME_NOMINUTESORSECONDS		0x01
#define TIME_NOSECONDS			0x02
#define TIME_NOTIMEMARKER		0x04
#define TIME_FORCE24HOURFORMAT		0x08

#define WC_DISCARDNS			0x0010
#define WC_SEPCHARS			0x0020
#define WC_DEFAULTCHAR			0x0040
#define WC_DEFAULTCHECK			0x0100
#define WC_COMPOSITECHECK		0x0200


typedef DWORD	 CALTYPE;
typedef DWORD	 CALID;
typedef	WORD	 LANGID;
typedef DWORD	 LCID;
typedef PDWORD	*PLCID;
typedef DWORD	 LCTYPE;

typedef BOOL (CALLBACK *CALINFO_ENUMPROCA)(LPSTR); 
typedef BOOL (CALLBACK *CODEPAGE_ENUMPROCA)(LPSTR); 
typedef BOOL (CALLBACK *DATEFMT_ENUMPROCA)(LPSTR); 
typedef BOOL (CALLBACK *LOCALE_ENUMPROCA)(LPSTR); 
typedef BOOL (CALLBACK *TIMEFMT_ENUMPROCA)(LPSTR); 

typedef BOOL (CALLBACK *CALINFO_ENUMPROCW)(LPWSTR); 
typedef BOOL (CALLBACK *CODEPAGE_ENUMPROCW)(LPWSTR); 
typedef BOOL (CALLBACK *DATEFMT_ENUMPROCW)(LPWSTR); 
typedef BOOL (CALLBACK *LOCALE_ENUMPROCW)(LPWSTR); 
typedef BOOL (CALLBACK *TIMEFMT_ENUMPROCW)(LPWSTR); 

#ifdef NOT
#ifndef UNICODE
#define CALINFO_ENUMPROC	CALINFO_ENUMPROCA
#define CODEPAGE_ENUMPROC	CODEPAGE_ENUMPROCA
#define DATEFMT_ENUMPROC	DATEFMT_ENUMPROCA
#define LOCALE_ENUMPROC		LOCALE_ENUMPROCA
#define TIMEFMT_ENUMPROC	TIMEFMT_ENUMPROCA
#else
#define CALINFO_ENUMPROC	CALINFO_ENUMPROCW
#define CODEPAGE_ENUMPROC	CODEPAGE_ENUMPROCW
#define DATEFMT_ENUMPROC	DATEFMT_ENUMPROCW
#define LOCALE_ENUMPROC		LOCALE_ENUMPROCW
#define TIMEFMT_ENUMPROC	TIMEFMT_ENUMPROCW
#endif
#endif

typedef struct __CPINFO
{ 
   UINT		MaxCharSize; 
   BYTE		DefaultChar[MAX_DEFAULTCHAR]; 
   BYTE		LeadByte[MAX_LEADBYTES]; 
} CPINFO, *PCPINFO, *LPCPINFO; 

typedef struct __CURRENCYFMTA
{
   UINT		NumDigits;
   UINT		LeadingZero;
   UINT		Grouping;
   LPSTR	lpDecimalSep;
   LPSTR	lpThousandSep;
   UINT		NegativeOrder;
   UINT		PositiveOrder;
   LPSTR	lpCurrencySymbol;
} CURRENCYFMTA, *PCURRENCYFMTA, *LPCURRENCYFMTA;

typedef struct __CURRENCYFMTW
{
   UINT		NumDigits;
   UINT		LeadingZero;
   UINT		Grouping;
   LPWSTR	lpDecimalSep;
   LPWSTR	lpThousandSep;
   UINT		NegativeOrder;
   UINT		PositiveOrder;
   LPWSTR	lpCurrencySymbol;
} CURRENCYFMTW, *PCURRENCYFMTW, *LPCURRENCYFMTW;

typedef struct __NUMBERFMTA
{ 
   UINT		NumDigits; 
   UINT		LeadingZero; 
   UINT		Grouping; 
   LPSTR	lpDecimalSep; 
   LPSTR	lpThousandSep; 
   UINT		NegativeOrder; 
} NUMBERFMTA, *PNUMBERFMTA, *LPNUMBERFMTA; 

typedef struct __NUMBERFMTW
{ 
   UINT		NumDigits; 
   UINT		LeadingZero; 
   UINT		Grouping; 
   LPWSTR	lpDecimalSep; 
   LPWSTR	lpThousandSep; 
   UINT		NegativeOrder; 
} NUMBERFMTW, *PNUMBERFMTW, *LPNUMBERFMTW; 
 
#define LANGIDFROMLCID( l )	((WORD)(l))
#define MAKELANGID( p, s )	((((WORD)(s))<<10)|(WORD)(p))
#define MAKELCID( l, s )	((DWORD)((((DWORD)((WORD)(s)))<<16)| \
					((DWORD)((WORD)(l)))))
#define PRIMARYLANGID( l )	((WORD)(l)&0x3FF)
#define SORTIDFROMLCID( l )	((WORD)((((DWORD)(l))&\
					NLS_VALID_LOCALE_MASK)>>16))
#define SUBLANGID( l )		((WORD)(l)>>10)

LPSTR
WINAPI
CharLowerA(
   LPSTR	lpsz
   );

LPWSTR
WINAPI
CharLowerW(
   LPWSTR	lpsz
   );

DWORD
WINAPI
CharLowerBuffA(
   LPSTR	lpsz,
   DWORD	cchLength
   );

DWORD
WINAPI
CharLowerBuffW(
   LPWSTR	lpsz,
   DWORD	cchLength
   );

LPSTR
WINAPI
CharNextA(
   LPCSTR	lpsz
   );

LPWSTR
WINAPI
CharNextW(
   LPCWSTR	lpsz
   );

LPSTR
WINAPI
CharPrevA(
   LPCSTR	lpszStart,
   LPCSTR	lpszCurrent
   );

LPWSTR
WINAPI
CharPrevW(
   LPCWSTR	lpszStart,
   LPCWSTR	lpszCurrent
   );

BOOL
WINAPI
CharToOemA(
   LPCSTR	lpszSrc,
   LPSTR	lpszDst
   );

BOOL
WINAPI
CharToOemW(
   LPCWSTR	lpszSrc,
   LPSTR	lpszDst
   );

BOOL
WINAPI
CharToOemBufA(
   LPCSTR	lpszSrc,
   LPSTR	lpszDst,
   DWORD	cchDstLength
   );

BOOL
WINAPI
CharToOemBuffW(
   LPCWSTR	lpszSrc,
   LPSTR	lpszDst,
   DWORD	cchDstLength
   );

LPSTR
WINAPI
CharUpperA(
   LPSTR	lpsz
   );

LPWSTR
WINAPI
CharUpperW(
   LPWSTR	lpsz
   );

DWORD
WINAPI
CharUpperBuffA(
   LPSTR	lpsz,
   DWORD	cchLength
   );

DWORD
WINAPI
CharUpperBuffW(
   LPWSTR	lpsz,
   DWORD	cchLength
   );

INT
WINAPI
CompareStringA(
   LCID		Locale,
   DWORD	dwCmpFlags,
   LPCSTR	lpString1,
   INT		cchCount1,
   LPCSTR	lpString2,
   INT		cchCount2
   );

INT
WINAPI
CompareStringW(
   LCID		Locale,
   DWORD	dwCmpFlags,
   LPCWSTR	lpString1,
   INT		cchCount1,
   LPCWSTR	lpString2,
   INT		cchCount2
   );
   
LCID
WINAPI
ConvertDefaultLocale(
   LCID		Locale
   );   

BOOL
WINAPI
EnumCalendarInfoA(
   CALINFO_ENUMPROCA lpCalInfoEnumProc,
   LCID		Locale,
   CALID	Calendar,
   CALTYPE	CalType
   );

BOOL
WINAPI
EnumCalendarInfoW(
   CALINFO_ENUMPROCW lpCalInfoEnumProc,
   LCID		Locale,
   CALID	Calendar,
   CALTYPE	CalType
   );

BOOL
WINAPI
EnumDateFormatsA(
   DATEFMT_ENUMPROCA lpDateFmtEnumProc,
   LCID		Locale,
   DWORD	dwFlags
   );

BOOL
WINAPI
EnumDateFormatsW(
   DATEFMT_ENUMPROCW lpDateFmtEnumProc,
   LCID		Locale,
   DWORD	dwFlags
   );

BOOL
WINAPI
EnumSystemCodePagesA(
   CODEPAGE_ENUMPROCA lpCodePageEnumProc,
   DWORD	dwFlags
   );

BOOL
WINAPI
EnumSystemCodePagesW(
   CODEPAGE_ENUMPROCW lpCodePageEnumProc,
   DWORD	dwFlags
   );

BOOL
WINAPI
EnumSystemLocalesA(
   LOCALE_ENUMPROCA lpLocaleEnumProc,
   DWORD	dwFlags
   );


BOOL
WINAPI
EnumSystemLocalesW(
   LOCALE_ENUMPROCW lpLocaleEnumProc,
   DWORD	dwFlags
   );

BOOL
WINAPI
EnumTimeFormatsA(
   TIMEFMT_ENUMPROCA lpTimeFmtEnumProc,
   LCID		Locale,
   DWORD	dwFlags
   );

BOOL
WINAPI
EnumTimeFormatsW(
   TIMEFMT_ENUMPROCW lpTimeFmtEnumProc,
   LCID		Locale,
   DWORD	dwFlags
   );

INT
WINAPI
FoldStringA(
   DWORD	dwMapFlags,
   LPCSTR	lpSrcStr,
   INT		cchSrc,
   LPSTR	lpDestStr,
   INT		cchDest
   );

INT
WINAPI
FoldStringW(
   DWORD	dwMapFlags,
   LPCWSTR	lpSrcStr,
   INT		cchSrc,
   LPWSTR	lpDestStr,
   INT		cchDest
   );

UINT 
WINAPI 
GetACP(VOID);

BOOL
WINAPI
GetCPInfo(
   UINT		CodePage,
   LPCPINFO	lpCPInfo
   );

INT
WINAPI
GetCurrencyFormatA(
   LCID		Locale,
   DWORD	dwFlags,
   LPCSTR	lpValue,
   CONST CURRENCYFMTA *lpFormat,
   LPSTR	lpCurrencyStr,
   INT		cchCurrency
   );

INT
WINAPI
GetCurrencyFormatW(
   LCID		Locale,
   DWORD	dwFlags,
   LPCWSTR	lpValue,
   CONST CURRENCYFMTW *lpFormat,
   LPWSTR	lpCurrencyStr,
   INT		cchCurrency
   );

INT
WINAPI
GetDateFormatA(
   LCID		Locale,
   DWORD	dwFlags,
   CONST SYSTEMTIME *lpDate,
   LPCSTR	lpFormat,
   LPSTR	lpDateStr,
   INT		cchDate
   );

INT
WINAPI
GetDateFormatW(
   LCID		Locale,
   DWORD	dwFlags,
   CONST SYSTEMTIME *lpDate,
   LPCWSTR	lpFormat,
   LPWSTR	lpDateStr,
   INT		cchDate
   );

INT
WINAPI
GetLocaleInfoA(
   LCID		Locale,
   LCTYPE	LCType,
   LPSTR	lpLCData,
   INT		cchData
   );
   
INT
WINAPI
GetLocaleInfoW(
   LCID		Locale,
   LCTYPE	LCType,
   LPWSTR	lpLCData,
   INT		cchData
   );

INT
WINAPI
GetNumberFormatA(
   LCID		Locale,
   DWORD	dwFlags,
   LPCSTR	lpValue,
   CONST NUMBERFMTA *lpFormat,
   LPSTR	lpNumberStr,
   INT		cchNumber
   );

INT
WINAPI
GetNumberFormatW(
   LCID		Locale,
   DWORD	dwFlags,
   LPCWSTR	lpValue,
   CONST NUMBERFMTW *lpFormat,
   LPWSTR	lpNumberStr,
   INT		cchNumber
   );

UINT
WINAPI
GetOEMCP(VOID);

LANGID
WINAPI
GetUserDefaultLangID(VOID);

LCID
WINAPI
GetUserDefaultLCID(VOID);

BOOL
WINAPI
GetStringTypeA(
   LCID		Locale,
   DWORD	dwInfoType,
   LPCSTR	lpSrcStr,
   INT		cchSrc,
   LPWORD	lpCharType
   );

BOOL
WINAPI
GetStringTypeW(
   DWORD	dwInfoType,
   LPCWSTR	lpSrcStr,
   INT		cchSrc,
   LPWORD	lpCharType
   );

BOOL
WINAPI
GetStringTypeExA(
   LCID		Locale,
   DWORD	dwInfoType,
   LPCSTR	lpSrcStr,
   INT		cchSrc,
   LPWORD	lpCharType
   );

BOOL
WINAPI
GetStringTypeExW(
   LCID		Locale,
   DWORD	dwInfoType,
   LPCWSTR	lpSrcStr,
   INT		cchSrc,
   LPWORD	lpCharType
   );
     
LANGID
WINAPI
GetSystemDefaultLangID(VOID);

LCID
WINAPI
GetSystemDefaultLCID(VOID);

INT
WINAPI
GetTimeFormatA(
   LCID		Locale,
   DWORD	dwFlags,
   CONST SYSTEMTIME *lpTime,
   LPCSTR	lpFormat,
   LPSTR	lpTimeStr,
   INT		cchTime
   );

INT
WINAPI
GetTimeFormatW(
   LCID		Locale,
   DWORD	dwFlags,
   CONST SYSTEMTIME *lpTime,
   LPCWSTR	lpFormat,
   LPWSTR	lpTimeStr,
   INT		cchTime
   );

LCID
WINAPI
GetThreadLocale(VOID);

BOOL
WINAPI
IsCharAlphaA(
   CHAR		ch
   );

BOOL
WINAPI
IsCharAlphaW(
   WCHAR	 ch
   );

BOOL
WINAPI
IsCharAlphaNumericA(
   CHAR		ch
   );

BOOL
WINAPI
IsCharAlphaNumericW(
   WCHAR	ch
   );

BOOL
WINAPI
IsCharLowerA(
   CHAR		ch
   );

BOOL
WINAPI
IsCharLowerW(
   WCHAR	ch
   );

BOOL
WINAPI
IsCharUpperA(
   CHAR		ch
   );

BOOL
WINAPI
IsCharUpperW(
   WCHAR	ch
   );

BOOL
WINAPI
IsDBCSLeadByte(
   BYTE		ch
   );

BOOL
WINAPI
IsDBCSLeadByteEx(
   UINT		CodePage,
   BYTE		ch
   );  
   
BOOL
WINAPI
IsValidCodePage(
   UINT		CodePage
   );

INT
WINAPI
LCMapStringA(
    LCID	Locale,
    DWORD	dwMapFlags,
    LPCSTR	lpSrcStr,
    INT		cchSrc,
    LPSTR	lpDestStr,
    INT		cchDest
    );

INT
WINAPI
LCMapStringW(
    LCID	Locale,
    DWORD	dwMapFlags,
    LPCWSTR	lpSrcStr,
    INT		cchSrc,
    LPWSTR	lpDestStr,
    INT		cchDest
    );

INT
WINAPI
MultiByteToWideChar(
   UINT		CodePage,
   DWORD	dwFlags,
   LPCSTR	lpMultiByteStr,
   INT		cchMultiByte,
   LPWSTR	lpWideCharStr,
   INT		cchWideChar
   );

BOOL
WINAPI
OemToCharA(
   LPCSTR	lpszSrc,
   LPSTR	lpszDst
   );

BOOL
WINAPI
OemToCharW(
   LPCSTR	lpszSrc,
   LPWSTR	lpszDst
   );

BOOL
WINAPI
OemToCharBuffA(
   LPCSTR	lpszSrc,
   LPSTR	lpszDst,
   DWORD	cchDstLength
   );

BOOL
WINAPI
OemToCharBuffW(
   LPCSTR	lpszSrc,
   LPWSTR	lpszDst,
   DWORD	cchDstLength
   );

BOOL
WINAPI
SetLocaleInfoA(
   LCID		Locale,
   LCTYPE	LCType,
   LPCSTR	lpLCData
   );

BOOL
WINAPI
SetLocaleInfoW(
   LCID		Locale,
   LCTYPE	LCType,
   LPCWSTR	lpLCData
   );

BOOL 
WINAPI
SetThreadLocale(
   LCID		Locale
   );

INT
WINAPI
WideCharToMultiByte(
   UINT		CodePage,
   DWORD	dwFlags,
   LPCWSTR	lpWideCharStr,
   INT		cchWideChar,
   LPSTR	lpMultiByteStr,
   INT		cchMultiByte,
   LPCSTR	lpDefaultChar,
   LPBOOL	lpUsedDefaultChar
   );

INT
CDECL
wsprintfA(LPSTR, LPCSTR, ...);

INT
CDECL
wsprintfW(LPWSTR, LPCWSTR, ...);

INT
WINAPI
wvsprintfA(
   LPSTR	lpBuffer,
   LPCSTR	lpszFormat,
   va_list	arglist
   );

INT
WINAPI
wvsprintfW(
   LPWSTR	lpBuffer,
   LPCWSTR	lpszFormat,
   va_list	arglist
   );

/* UNICODE */
#ifndef UNICODE 
#define CharLowerBuff		CharLowerBuffA
#define CharLower		CharLowerA
#define CharNext		CharNextA
#define CharPrev		CharPrevA
#define CharUpperBuff		CharUpperBuffA
#define CharUpper		CharUpperA
#define CharToOem		CharToOemA
#define CharToOemBuff		CharToOemBuffA
#define CompareString 		CompareStringA
#define EnumSystemCodePages	EnumSystemCodePagesA
#define EnumSystemLocales	EnumSystemLocalesA
#define EnumCalendarInfo	EnumCalendarInfoA
#define EnumDateFormats		EnumDateFormatsA
#define EnumTimeFormats		EnumTimeFormatsA
#define GetCurrencyFormat	GetCurrencyFormatA
#define GetDateFormat		GetDateFormatA
#define GetTimeFormat		GetTimeFormatA
#define GetLocaleInfo		GetLocaleInfoA
#define GetNumberFormat		GetNumberFormatA
#define GetStringTypeEx		GetStringTypeExA
#define FoldString		FoldStringA
#define FormatMessage		FormatMessageA
#define IsCharAlpha		IsCharAlphaA
#define IsCharAlphaNumeric	IsCharAlphaNumericA
#define IsCharLower		IsCharLowerA
#define IsCharUpper		IsCharUpperA
#define LCMapString		LCMapStringA
#define OemToChar		OemToCharA
#define OemToCharBuff		OemToCharBuffA
#define SetLocaleInfo		SetLocaleInfoA
#define wsprintf		wsprintfA
#define wvsprintf		wvsprintfA
#else
#define CharLowerBuff		CharLowerBuffW
#define CharLower		CharLowerW
#define CharNext		CharNextW
#define CharPrev		CharPrevW
#define CharUpperBuff		CharUpperBuffW
#define CharUpper		CharUpperW
#define CharToOem		CharToOemW
#define CharToOemBuff		CharToOemBuffW
#define CompareString 		CompareStringW
#define EnumSystemCodePages	EnumSystemCodePagesW
#define EnumSystemLocales	EnumSystemLocalesW
#define EnumCalendarInfo	EnumCalendarInfoW
#define EnumDateFormats		EnumDateFormatsW
#define EnumTimeFormats		EnumTimeFormatsW
#define GetCurrencyFormat	GetCurrencyFormatW
#define GetDateFormat		GetDateFormatW
#define GetTimeFormat		GetTimeFormatW
#define GetLocaleInfo		GetLocaleInfoW
#define GetNumberFormat		GetNumberFormatW
#define GetStringTypeEx		GetStringTypeExW
#define FoldString		FoldStringW
#define FormatMessage		FormatMessageW
#define IsCharAlpha		IsCharAlphaW
#define IsCharAlphaNumeric	IsCharAlphaNumericW
#define IsCharLower		IsCharLowerW
#define IsCharUpper		IsCharUpperW
#define LCMapString		LCMapStringW
#define OemToChar		OemToCharW
#define OemToCharBuff		OemToCharBuffW
#define SetLocaleInfo		SetLocaleInfoW
#define wsprintf		wsprintfW
#define wvsprintf		wvsprintfW
#endif

#ifdef __cplusplus
}
#endif 

#endif /* __WIN32_NLS_H */