/*
 * kernel/debug.c
 * Copyright (C) 1996, Onno Hovers, All rights reserved
 */

#include <stdio.h>
#include <win32/defines.h>
#include "wfc.h"

#undef aprintf
#undef dprintf

VOID aprintf(const char *fmt, ...);  /* API logging */
VOID dprintf(const char *fmt, ...);  /* debugging   */

VOID dprintf(const char * fmt, ...)
{
   if(__DbgLog)
   {
      CHAR buffer[1024];   
      va_list args;
    
      va_start(args,fmt);
      vsprintf(buffer,fmt,args);
      va_end(args);
      fprintf( __DbgOut, "DEBUG: %s", buffer);
      fflush( __DbgOut );
   }   
}

VOID aprintf(const char * fmt, ...)
{
   if(__ApiLog)
   {
      CHAR buffer[1024];   
      va_list args;
    
      va_start(args,fmt);
      vsprintf(buffer,fmt,args);
      va_end(args);
      fprintf( __ApiOut, "API: %s", buffer);
      fflush( __ApiOut );
   }   
}