/*
 * kernel/init.c
 * Copyright 1996, Onno Hovers, All rights reserved  
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; see the file COPYING.LIB. If
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave,
 * Cambridge, MA 02139, USA.  
 *
 * useage
 * wfc [OPTIONS] filename args
 *
 * versions 
 * -e			
 * --emulate
 * 	 32s/95/nt
 * -v
 * --version
 * 	 x.xx[s/c/n]
 */

#include<stdlib.h>
#include<stdio.h>
#include<win32/defines.h>
#include"exe.h"
#include"rtlmem.h"
#include"peload.h"
#include"thread.h"
#include"run.h"
#include"process.h"
#include"virtual.h"
#include"wfc.h"
#include"run.h"
#include"fs.h"
#include"lctable.h"

#ifdef NOTYET
/* if we sense that we have been started by CreateProcess,
 * we have to copy some data from our dear parent:
 *
 * arg0: progname
 * arg1: --intern
 * arg2: cmdline
 * env: %X  = intern
 *      %%X = %X
 *
 */
 
int newstart(int argc, char **argv, char **environ)
{
   LPSTR env;
   LPSTR str;
   INT   envcount;
   
}

#endif

int main(int argc, char *argv[])
{
   INT   cmd;
   INT   i;
   INT   cmdlen;
   LPSTR pext;
   CHAR  command[MAX_PATH];

#ifdef __i386__
   /* initialize teb */
   __ThreadInitTeb();
#endif
   
   puts("WinFree Win32 Command Line App Emulator (C) 1996, Onno Hovers\n");
   
   cmd=1;
   while(argv[cmd][0]=='-')
   {
      switch(argv[cmd][1])
      {
         case 'w':
            switch(argv[cmd][2])
            {
               case '3':
               case 's':
                  __WindowsEmulate=VER_PLATFORM_WIN32s; break;
               case 'c':
               case '9':
                  __WindowsEmulate=VER_PLATFORM_WIN32_WINDOWS; break;
               case 'n':
                  __WindowsEmulate=VER_PLATFORM_WIN32_NT; break;
               case 'f':
                  __WindowsEmulate=VER_PLATFORM_WIN32_FREE; break;
            }
            break;         
         case 'v':
            break;           
         case 'd':
            if(strcmp(argv[cmd]+2,"on")==0)
               { __DbgLog=TRUE; }
            else if(strcmp(argv[cmd]+2,"off")==0)
               { __DbgLog=FALSE; } ;
            break;
      }
      cmd++;   
   }
   /* initialize memory */
   /* __HeapInit(); */
   __VirtualInit();
   
   /* now get the name of the program to launch */    
   cmdlen=1;
   for( i=cmd ; i<argc ; i++ )
   {
      cmdlen=cmdlen+strlen(argv[i])+1;
   }
   
   /* get current directory: XXX should be in fs.c */
   __CommandLineA=imalloc(cmdlen);
   __CommandLineA[0]='\0';

   for( i=cmd ; i<argc ; i++ )
   {       
      strcat(__CommandLineA,argv[i]);
      strcat(__CommandLineA," ");
   };
   
   dprintf("commandline=%s\n",__CommandLineA);
   
   __HandleInit();
   __LocaleInit();
   __FsInit();
   __FileInit();
   __ImageInit();  
   __EnvironmentInit();
   
   /* append .exe if necessary */
   istrcpy(command,argv[cmd],PATH_MAX);
   pext=strrchr(command,'.');
   if((!pext)||(strcasecmp(pext,".exe")))
      istrcat(command,".exe",PATH_MAX);
              
   dprintf("loading exe %s\n",command);
   __ImageExecutable=__ImageLoadModule(command);
   if(__ImageExecutable)
   {
      __CallInitFirstThread(__ProcessStart,NULL);
      puts("so far so good!\n"); fflush(stdout);
   }
   else
   {
      puts("could not load file!\n"); 
   }   

   /* just to keep gcc happy */
   return 1;
}