/*
 * kernel/mapping.h
 * Copyright (C) 1996, Onno Hovers, All rights reserved
 *
 * 
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; see the file COPYING.LIB. If
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave,
 * Cambridge, MA 02139, USA.  
 */
 
#ifndef __KERNEL_MAPPING_H
#define __KERNEL_MAPPING_H

#include <stddef.h>
#include <win32/defines.h>
#include <win32/error.h>
#include <win32/kernel.h>
#include "object.h"
#include "imalloc.h"
#include "mapping.h"

#ifdef __cplusplus
extern "C" {
#endif
 
MAPPING_CLASS __MapClass;

BOOL  __MapInit(PKERNEL_OBJECT pfile);
BOOL  __MapIsType(PKERNEL_OBJECT pfile, ULONG typeid);
BOOL  __MapClose(PKERNEL_OBJECT pfile);
BOOL  __MapCreate( )
{
  



};

BOOL  __MapOpen( )
{
   

};

BOOL  __MapMap( PMAPPING_OBJECT pmapping, LPVOID base, DWORD access, 
                  ULONGLONG offset, ULONG size )
{
   return __VirtualMapping(base, size, access, pmapping, offset); 
}

BOOL  __MapUnmap()
{
   return __VirtualRelease(base);
}

BOOL __MapFlush( PVOID base )
{
   PVM_AREA area;
   
   area=__VirtualFindArea()
   if((area)&&(area->Type==VM_MAPPING))
   {
      if(msync(base, area->Size, MS_SYNC )==-1)
         return __ErrorReturnFalse(__ErrorFromErrno(errno));
   }
   return TRUE;
}

#ifdef __cplusplus
}
#endif

#endif