/*
 * kernel/profile.c
 * Copyright (C) 1996, Onno Hovers, All rights reserved
 * 
 * This is basically a hack to make tlink32 work
 * Profiles really should be done in some kind of server. 
 * Imagine e.g. two processes changing a .ini file. 
 * Wine's caching a *.ini file really loses out in such an environment 
 * These profile functions lose in a 32 bit environment, anyway 
 * That's why microsoft is moving towards the registry-nightmare. 
 */

#include <stdio.h>
#include <win32/defines.h>
#include <win32/kernel.h>
#include "rtlmem.h"
#include "wfc.h"

DWORD WINAPI GetPrivateProfileStringA( LPCSTR section, LPCSTR key,
                                       LPCSTR defval, LPSTR buffer,
                                       DWORD len, LPCSTR filename )
{
   aprintf("GetPrivateProfileStringA( %s, %s, %s, 0x%lX, %ld, %s )\n",
           section, key, defval, (ULONG) buffer, len, filename ); 
   return istrcpy(buffer, defval, len);   
}                               