/*
 * kernel/security.c
 * Copyright (C) 1996, Onno Hovers, All rights reserved 
 * 
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; see the file COPYING.LIB. If
 * not, write to the Free Software Foundation, Inc., 675 Mass Ave,
 * Cambridge, MA 02139, USA.  
 */

#include<win32/defines.h>
#include<win32/security.h>

/********************************************************************
*                    MapGenericMask  --  ADVAPI32                   *
*                                                                   *
*  translates GENERIC_X bits in an access mask                      *
*                                                                   *
********************************************************************/

VOID MapGenericMask(PDWORD paccess, PGENERIC_MAPPING pgenmap)
{
   register DWORD access;

   access=*paccess;
   
   if(access & GENERIC_READ)
      access=access | pgenmap->GenericRead;
   if(access & GENERIC_WRITE)
      access=access | pgenmap->GenericWrite;
   if(access & GENERIC_EXECUTE)
      access=access | pgenmap->GenericExecute;
   access=access & pgenmap->GenericAll;
   
   *paccess=access;
}
