/*
 * kernel/shared.c
 * Copyright (C) 1996, Onno Hovers, All rights reserved
 *
 * shared heap handling
 */

#define SHHSIZE		128*1024
#define SHH_MAX_ALLOC	4*1024

INT shhKey;

#define SHH_MAGIC_MASK		0xFF000000
#define SHH_MAGIC_ALLOCATED	0xA1000000
#define SHH_MAGIC_FREE		0xF1000000

typedef struct __SHARED_ARENA
{       
   DWORD		Size;
   struct SHARED_ARENA	*Prev;
} SHARED_ARENA, *PSHARED_ARENA;
 
 
typedef struct __SHARED_HEAP
{
   DWORD	Magic;
   /* lock */
   INT		Semaphore;
   PSHARED_FREE	FreeList;  
} SHARED_HEAP, *PSHARED_HEAP;

PSHARED_HEAP shhHeap;

BOOL shhInit1(VOID)
{
   shhKey=shmget(IPC_PRIVATE, SHH_SIZE, IPC_CREAT| IPC_EXCL|  0700);   

}

BOOL shhDone1(VOID)
{
}

PVOID shhAlloc(DWORD size)
{
   PSHARED_FREE pfree;
   
   size=ROUNDUP(size+8,16);
   if(size>SHH_MAX_ALLOC)
      return __ErrorReturnNull(ERROR_OUTOFMEMORY);  
   shhEnter();
       
      pfree=shhHeap->FreeList;  
      while(1)
      {
         if(!pfree)
           { SetLastError(ERROR_OUTOFMEMORY); retval=NULL; break }
         if((pfree->Size & SHH_MAGIC_MASK)!=MAGIC_SHH_FREE)
         { 
            perror("wfc internal error: shared heap corrupted\n"); 
            SetLastError(ERROR_ARENA_TRASHED);
            retval=NULL;
         }  
         if(pfree->Size<=size)
         {
            if(pfree->Size<size)
            {           
               pnewfree=(PSHARED_FREE)(((PBYTE)pfree)+size);           
               pnewfree->Size=pfree->Size-size | MAGIC_SHH_FREE;
               pnewfree->Prev=pfree;
            }
            pfree->Alloc=size | MAGIC_SHH_ALLOCATED;
            break;
         }
         pfree=(PSHARED_ARENA)(((PBYTE)pfree)+pfree->Size);      
      }   
   shhLeave();
}

BOOL shhFree(LPVOID ptr)
{
  PSHARED_ARENA pfree;
  PSHARED_ARENA pnext;
  PSHARED_ARENA pprev;
  
  if(((ULONG) ptr < (ULONG) shhHeap)||
     ((ULONG) ptr > ((ULONG) shhHeap) + SHHSIZE)) 
     return FALSE; 
  
  pfree=(PSHARED_ARENA) ptr; 
  shhEnter();
     if((pfree->Size & SHH_MAGIC_MASK)==MAGIC_SHH_ALLOCATED)
     {
         pprev=pfree->Prev;
         if((pprev!=NULL)&&((prev && SHH_MAGIC_MASK)==SHH_MAGIC_FREE))
         {
            pprev->Size=pprev->Size+pfree->Size;
            pprev=
         }
         pnext=(PSHARED_ARENA)(((PBYTE)pfree)+pfree->Size);      
                  
     }
  shhLeave();
}