/*
 * nls/codepage.c
 *
 *
 */

#include<win32/defines.h>
#include<win32/nls.h>
#include<win32/error.h>
#include"wfc.h"
#include"cptable.h"
#include"error.h"


UINT WINAPI GetACP(void)
{
   aprintf("GetACP()\n");
   
   /* XXX: read from registry, take this as default */
   return __TebLocale->AnsiCodePage->Id;
}

UINT WINAPI GetOEMCP(void)
{
   aprintf("GetOEMCP()\n");
   /* XXX: read from registry, take this as default */
   return __TebLocale->OemCodePage->Id;
}

BOOL WINAPI IsValidCodePage(UINT codepage)
{
   PCODEPAGE pcp;
 
   aprintf("IsValidCodePage( %u )\n", codepage);  
   
   switch(codepage)
   {
      case CP_ACP:   return TRUE;
      case CP_OEMCP: return TRUE; 
      case CP_MACCP: return TRUE;
      default:
         pcp=__CPFirst;
         while((pcp)&&(pcp->Id!=codepage))
            pcp=pcp->Next;
         return pcp ? TRUE : FALSE;      
   }
}

BOOL GetCPInfo(UINT codepage, PCPINFO pcpinfo)
{
    PCODEPAGE pcp;
   
    aprintf("GetCPInfo( %u, 0x%lX )\n", codepage, (ULONG) pcpinfo);
    
    pcp=__CPFirst;
    while((pcp)&&(pcp->Id!=codepage))
            pcp=pcp->Next;  
    if(!pcp)
       return __ErrorReturnFalse(ERROR_INVALID_PARAMETER);
    if(!pcp->Info)
       return __ErrorReturnFalse(ERROR_INVALID_PARAMETER);
       
    memcpy(pcpinfo,pcp->Info,sizeof(CPINFO));
    return TRUE;
}