/*
 * nls/wctomb.c
 * Copyright (c) 1996, Onno Hovers, All rights reserved
 */
 
#include <win32/defines.h>
#include <win32/kernel.h>
#include <win32/nls.h>
#include <win32/error.h>
#include "wfc.h"
#include "cptable.h"
#include "lctable.h"
#include "wcstring.h"
#include "teb.h"
 
INT MultiByteToWideChar(UINT cpid, DWORD flags, LPCSTR src, int srclen,
                        LPWSTR dest, int destlen)
{
   PCODEPAGE pcodepage;
   INT       copylen;
   INT       retlen;  
   WCHAR     **atou;
   CHAR      c;  
  
   aprintf("MultiByteToWideChar( %u, 0x%lX, %s, %d, 0x%lX, %d )\n", 
           cpid, flags, src, srclen, (ULONG) dest, destlen);
    
   /* get codepage */
   switch(cpid)
   {
      case CP_ACP:   pcodepage=__TebLocale->OemCodePage;  break;
      case CP_OEMCP: pcodepage=__TebLocale->AnsiCodePage; break;
      case CP_MACCP: pcodepage=&__CP10000;   break;
      default:
         pcodepage=__CPFirst;
         while((pcodepage)&&(pcodepage->Id!=cpid))
            pcodepage=pcodepage->Next;
   } 
   if(pcodepage==NULL)
      { SetLastError(ERROR_INVALID_PARAMETER); return 0; }
      
   /* get conversion table */
   atou=pcodepage->ToUnicode;
   
   if(destlen!=0)
   {
      /* how long are we ?? */   
      if(srclen==0)
         srclen=strlen(src);
   
      copylen=min(srclen,destlen);
      retlen=copylen;
      
      /* XXX: maybe some inline assembly to speed things up, here ??? */
      while(copylen>0)
      {
         c=*src;
         *dest=atou [c>>5] [(c)&0x1F];
         src++;
         dest++;
         copylen--;       
      }
   }
   else
   {
      /* XXXX: composites etc. */
      retlen = strlen(src);
   }
   return retlen;
}                         