/*
 *  nls/wcstring.c
 *  Copuright (C) 1996, Onno Hovers
 *
 *  Based on linux/lib/string.c, copyright (C) 1991, 1992  Linus Torvalds
 */

#include<win32/defines.h>

LPWSTR wcscpy(LPWSTR dest, LPCWSTR src)
{
   LPWSTR tmp = dest;

   while ((*dest++ = *src++) != '\0')
      /* nothing */;
   return tmp;
}

LPWSTR wcsncpy(LPWSTR dest,LPCWSTR src,INT count)
{
   LPWSTR tmp = dest;

   while (count-- && (*dest++ = *src++) != '\0')
      /* nothing */;

   return tmp;
}

LPWSTR wcscat(LPWSTR dest, LPCWSTR src)
{
   LPWSTR tmp = dest;

   while (*dest)
      dest++;
   while ((*dest++ = *src++) != '\0')
      /* nothing */;

   return tmp;
}

LPWSTR wcsncat(LPWSTR dest, LPCWSTR src, INT count)
{
   LPWSTR tmp = dest;

   if(count)
   {
      while(*dest)
         dest++;
      while ((*dest++ = *src++))
      {
         if(--count == 0)
         {
            *dest = '\0';
            break;
         }
      }
   }
   return tmp;
}

INT wcscmp(LPCWSTR cs, LPCWSTR ct)
{
   register short __res;

   while(1)
   {
      if((__res = *cs - *ct++) != 0 || !*cs++)
         break;
   }
   return __res;
}

INT wcsncmp(LPCWSTR cs, LPCWSTR ct, INT count)
{
   register short __res = 0;

   while (count)
   {
      if((__res = *cs - *ct++) != 0 || !*cs++)
         break;
      count--;
   }
   return __res;
}

LPWSTR wcschr(LPWCSTR s, INT c)
{
   for(; *s != (char) c; ++s)
      if (*s == '\0')
          return NULL;
   return (LPWSTR) s;
}

LPWSTR wcsrchr(LPCWSTR s, INT c)
{
   LPCWSTR p = s + wcslen(s);
   do 
   {
      if (*p == (char)c)
          return (char *)p;
   } 
   while (--p >= s);
   return NULL;
}

INT wcslen(LPCWSTR s)
{
   LPCWSTR sc;

   for(sc = s; *sc != '\0'; ++sc)
      /* nothing */;
   return sc - s;
}

INT wcsnlen(LPCWSTR s, INT count)
{
   LPCWSTR sc;

   for(sc = s; count-- && *sc != '\0'; ++sc)
      /* nothing */;
   return sc - s;
}

INT wcsspn(LPCWSTR s, LPCWSTR accept)
{
	const char *p;
	const char *a;
	size_t count = 0;

	for (p = s; *p != '\0'; ++p) {
		for (a = accept; *a != '\0'; ++a) {
			if (*p == *a)
				break;
		}
		if (*a == '\0')
			return count;
		++count;
	}

	return count;
}

LPSTR wcspbrk(LPCWSTR cs, LPCWSTR ct)
{
   LPCWSTR  sc1, sc2;

   for( sc1 = cs; *sc1 != '\0'; ++sc1)
   {
      for( sc2 = ct; *sc2 != '\0'; ++sc2)
      {
         if(*sc1 == *sc2)
            return (char *) sc1;
      }
   }
   return NULL;
}

LPWSTR wcsstr(LPCWSTR s1, LPCWSTR s2)
{
   INT l1, l2;

   l2 = wcslen(s2);
   if (!l2)
      return (char *) s1;
   l1 = wcslen(s1);
   while(l1 >= l2)
   {
      l1--;
      if(!wcsncmp(s1,s2,l2))
         return (char *) s1;
      s1++;
   }
   return NULL;
}